searchData={"items":[{"type":"module","title":"Mobius","doc":"Localized metrics reporter","ref":"Mobius.html"},{"type":"function","title":"Mobius.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Mobius.html#child_spec/1"},{"type":"function","title":"Mobius.get_latest_events/1","doc":"Get the latest events\n\nThe latest events are the events recorded between the last query for the\nevents and the query for the events that is being called.","ref":"Mobius.html#get_latest_events/1"},{"type":"function","title":"Mobius.get_latest_metrics/1","doc":"Get the latest metrics\n\nThe latest metrics are the metrics recorded between the last query for the\nmetrics and the query for the metrics that is being called.","ref":"Mobius.html#get_latest_metrics/1"},{"type":"function","title":"Mobius.info/0","doc":"Get the current metric information\n\nIf you configured Mobius to use a different name then you can pass in your\ncustom name to ensure Mobius requests the metrics from the right place.","ref":"Mobius.html#info/0"},{"type":"function","title":"Mobius.info/1","doc":"","ref":"Mobius.html#info/1"},{"type":"function","title":"Mobius.save/0","doc":"Persist the metrics to disk","ref":"Mobius.html#save/0"},{"type":"function","title":"Mobius.save/1","doc":"","ref":"Mobius.html#save/1"},{"type":"function","title":"Mobius.start_link/1","doc":"Start Mobius","ref":"Mobius.html#start_link/1"},{"type":"type","title":"Mobius.arg/0","doc":"Arguments to Mobius\n\n* `:name` - the name of the mobius instance (defaults to `:mobius`)\n* `:metrics` - list of telemetry metrics for Mobius to track\n* `:persistence_dir` - the top level directory where mobius will persist\n* `:autosave_interval` - time in seconds between automatic writes of the\n   persistence data (default disabled) metric information\n* `:database` - the `Mobius.RRD.t()` to use. This will default to the default\n   values found in `Mobius.RRD`\n* `:events` - a list of events for mobius to store in the event log\n* `:event_log_size` - number of events to store (defaults to 500)\n* `:clock` - module that implements the `Mobius.Clock` behaviour\n* `:session` - a unique id to distinguish between different ties Mobius has ran\n\nMobius sessions allow you collect events to analyze across the different times\nmobius ran. A good example of this might be measuring how fast an interface\nmakes its first connection. You can build averages over run times and measure\nconnection performance. This will allow you to know on average how fast a\ndevice connects so you can check for increased or decreased performance between\nruns.\n\nBy default Mobius will generate an UUID for each run.","ref":"Mobius.html#t:arg/0"},{"type":"type","title":"Mobius.event_def/0","doc":"","ref":"Mobius.html#t:event_def/0"},{"type":"type","title":"Mobius.event_measurement_values/0","doc":"A function to process an event's measurements\n\nThis will be called on each measurement and will receive a tuple where the\nfirst element is the name of the measurement and the second element is the\nvalue. This function can process the value and return a new one.","ref":"Mobius.html#t:event_measurement_values/0"},{"type":"type","title":"Mobius.event_opt/0","doc":"Options you can pass an event\n\nThese options only apply to the `:event` argument to Mobius. If you want\nto track metrics please see the `:metrics` argument to Mobius.\n\n* `:tags` - list of tag names to save with the event\n* `:measurement_values` - a function that will receive each measurement that\n  allows for data processing before storing the event in the event log\n* `:group` - an atom that defines the event group, this will allow for filtering\n  on particular types of events for example: `:network`. Default is `:default`","ref":"Mobius.html#t:event_opt/0"},{"type":"type","title":"Mobius.instance/0","doc":"The name of the Mobius instance\n\nThis is used to store data for a particular set of mobius metrics.","ref":"Mobius.html#t:instance/0"},{"type":"type","title":"Mobius.metric/0","doc":"A single metric data point\n\n* `:type` - the type of the metric\n* `:value` - the value of the measurement for the metric\n* `:tags` - a map of the tags for the metric\n* `:timestamp` - the naive time in seconds the metric was sampled\n* `:name` - the name of the metric","ref":"Mobius.html#t:metric/0"},{"type":"type","title":"Mobius.metric_name/0","doc":"The name of the metric\n\nExample: `\"vm.memory.total\"`","ref":"Mobius.html#t:metric_name/0"},{"type":"type","title":"Mobius.metric_type/0","doc":"","ref":"Mobius.html#t:metric_type/0"},{"type":"type","title":"Mobius.session/0","doc":"","ref":"Mobius.html#t:session/0"},{"type":"type","title":"Mobius.time_unit/0","doc":"","ref":"Mobius.html#t:time_unit/0"},{"type":"type","title":"Mobius.timestamp/0","doc":"","ref":"Mobius.html#t:timestamp/0"},{"type":"behaviour","title":"Mobius.Clock","doc":"Behaviour for Mobius to check if the clock is set\n\nOn systems that need to set the time after boot events, metrics might\nreport a nonsensical timestamp. Providing a clock implementation allows Mobius\nto make time adjustments on data received before the clock was set.\n\nIf no clock implementation is provided no time adjustments will be made.\n\nFor Nerves devices, [NervesTime](https://hex.pm/packages/nerves_time) can be\nused to track time synchronization.\n\n```elixir\n{Mobius, clock: NervesTime}\n```\n\nThe time adjustments are best effort and might not be 100% exact, but this should\nonly affect events that take place during the early stages of system boot.","ref":"Mobius.Clock.html"},{"type":"callback","title":"Mobius.Clock.synchronized?/0","doc":"Callback to check if the clock is synchronized","ref":"Mobius.Clock.html#c:synchronized?/0"},{"type":"module","title":"Mobius.Event","doc":"An single event","ref":"Mobius.Event.html"},{"type":"function","title":"Mobius.Event.new/5","doc":"Create a new event","ref":"Mobius.Event.html#new/5"},{"type":"function","title":"Mobius.Event.set_timestamp/2","doc":"","ref":"Mobius.Event.html#set_timestamp/2"},{"type":"type","title":"Mobius.Event.name/0","doc":"The name of the event","ref":"Mobius.Event.html#t:name/0"},{"type":"type","title":"Mobius.Event.new_opt/0","doc":"Options for creating a new event","ref":"Mobius.Event.html#t:new_opt/0"},{"type":"type","title":"Mobius.Event.t/0","doc":"An event","ref":"Mobius.Event.html#t:t/0"},{"type":"module","title":"Mobius.EventLog","doc":"API for working with the event log","ref":"Mobius.EventLog.html"},{"type":"function","title":"Mobius.EventLog.events_to_binary/1","doc":"Turn a list of Events into a binary","ref":"Mobius.EventLog.html#events_to_binary/1"},{"type":"function","title":"Mobius.EventLog.list/1","doc":"List the events in the event log","ref":"Mobius.EventLog.html#list/1"},{"type":"function","title":"Mobius.EventLog.parse/1","doc":"Parse the Mobius binary formatted event log","ref":"Mobius.EventLog.html#parse/1"},{"type":"function","title":"Mobius.EventLog.save/1","doc":"Save the current state of the event log to disk","ref":"Mobius.EventLog.html#save/1"},{"type":"function","title":"Mobius.EventLog.to_binary/1","doc":"Return the event log in the Mobius binary format","ref":"Mobius.EventLog.html#to_binary/1"},{"type":"type","title":"Mobius.EventLog.opt/0","doc":"Options to query the event log","ref":"Mobius.EventLog.html#t:opt/0"},{"type":"module","title":"Mobius.Exports","doc":"Support retrieving historical data in different formats\n\nCurrent formats:\n\n* CSV\n* Series\n* Line plot\n* Mobius Binary Format (MBF)\n\nThe Mobius Binary Format (MBF) is a format that contains the current state of\nall metrics. This binary format is useful for transferring metric information in\na format that other services can parse and use. For more details see `mbf/1`.","ref":"Mobius.Exports.html"},{"type":"function","title":"Mobius.Exports.csv/4","doc":"Generate a CSV for the metric\n\nPlease see `Mobius.Exporters.CSV` for more information.\n\n```elixir\n# Return CSV as string\n{:ok, csv_string} = Mobius.Exports.csv(\"vm.memory.total\", :last_value, %{})\n\n# Write to console\nMobius.Exports.csv(\"vm.memory.total\", :last_value, %{}, iodevice: :stdio)\n\n# Write to a file\nfile = File.open(\"mycsv.csv\", [:write])\n:ok = Mobius.Exports.csv(\"vm.memory.total\", :last_value, %{}, iodevice: file)\n```","ref":"Mobius.Exports.html#csv/4"},{"type":"function","title":"Mobius.Exports.mbf/1","doc":"Export all metrics in the Mobius Binary Format (MBF)\n\nThis is mostly useful when you want to share metric data with different\nnetworked services.\n\nThe binary format is `< >`\n\nThe first byte is the version number of the following metric data. Currently,\nthe version number is `1`.\n\nThe metric data binary is the type of `[Mobius.metric()]` encoded in Binary\nERlang Term format (BERT) and compressed (using Zlib compression).\n\nOptionally, `to_mbf/1` can write the binary to a file using the `:out_dir`\noption.\n\n```elixir\nMobius.Exports.to_mbf(out_dir: \"/my/dir\")\n```\n\nThe generated file is returned as `{:ok, filename}`. The format of the\nfile name is `YYYYMMDDHHMMSS-metrics.mbf`.\n\nSee `Mobius.Exports.parse_mbf/1` to parse a binary in MBF.","ref":"Mobius.Exports.html#mbf/1"},{"type":"function","title":"Mobius.Exports.metrics/4","doc":"Retrieve the raw metric data from the history store for a given metric.\n\nOutput will be a list of metric values, which will be in the format, eg:\n  `%{type: :last_value, value: 12, tags: %{interface: \"eth0\"}, timestamp: 1645107424}`\n\n  If there are tags for the metric you can pass those in the third argument:\n\n```elixir\nMobius.Exports.metrics(\"vm.memory.total\", :last_value, %{some: :tag})\n```\n\nBy default the filter will display the last 3 minutes of metric history.\n\nHowever, you can pass the `:from` and `:to` options to look at a specific\nrange of time.\n\n```elixir\nMobius.Exports.metrics(\"vm.memory.total\", :last_value, %{}, from: 1630619212, to: 1630619219)\n```\n\nYou can also filter data over the last `x` amount of time. Where x is an\ninteger. When there is no `time_unit()` provided the unit is assumed to be\n`:second`.\n\nRetrieving data over the last 30 seconds:\n\n```elixir\nMobius.Exports.metrics(\"vm.memory.total\", :last_value, %{}, last: 30)\n```\n\nRetrieving data over the last 2 hours:\n\n```elixir\nMobius.Exports.metrics(\"vm.memory.total\", :last_value, %{}, last: {2, :hour})\n```\n\nRetrieving summary data can be performed by specifying the type: :summary - however, this returns\nvalue data in the form of a map, which cannot be plotted or csv exported. To reduce the output to\na single metric value, use the form: {:summary, :summary_metric}\n\n```elixir\nMobius.Exports.metrics(\"vm.memory.total\", {:summary, :average}, %{}, last: {2, :hour})\n```","ref":"Mobius.Exports.html#metrics/4"},{"type":"function","title":"Mobius.Exports.parse_mbf/1","doc":"Parse the mobius binary format into a list of metrics","ref":"Mobius.Exports.html#parse_mbf/1"},{"type":"function","title":"Mobius.Exports.plot/4","doc":"Plot the metric name to the screen\n\nThis takes the same arguments as for filter_metrics, eg:\n\nIf there are tags for the metric you can pass those in the second argument:\n\n```elixir\nMobius.Exports.plot(\"vm.memory.total\", :last_value, %{some: :tag})\n```\n\nBy default the plot will display the last 3 minutes of metric history.\n\nHowever, you can pass the `:from` and `:to` options to look at a specific\nrange of time.\n\n```elixir\nMobius.Exports.plot(\"vm.memory.total\", :last_value, %{}, from: 1630619212, to: 1630619219)\n```\n\nYou can also plot data over the last `x` amount of time. Where x is an\ninteger. When there is no `time_unit()` provided the unit is assumed to be\n`:second`.\n\nPlotting data over the last 30 seconds:\n\n```elixir\nMobius.Export.plot(\"vm.memory.total\", :last_value, %{}, last: 30)\n```\n\nPlotting data over the last 2 hours:\n\n```elixir\nMobius.Export.plot(\"vm.memory.total\", :last_value, %{}, last: {2, :hour})\n```\n\nRetrieving summary data can be performed by specifying type of the form:\n  `{:summary, :summary_metric}`\n\n```elixir\nMobius.Exports.metrics(\"vm.memory.total\", {:summary, :average}, %{}, last: {2, :hour})\n```","ref":"Mobius.Exports.html#plot/4"},{"type":"function","title":"Mobius.Exports.series/4","doc":"Generates a series that contains the value of the metric","ref":"Mobius.Exports.html#series/4"},{"type":"type","title":"Mobius.Exports.csv_export_opt/0","doc":"Options for exporting a CSV","ref":"Mobius.Exports.html#t:csv_export_opt/0"},{"type":"type","title":"Mobius.Exports.export_metric_type/0","doc":"Metric types that can be exported\n\nBy default you can try to export any `Mobius.metric_type()`, but for the\nsummary metric type you can specify which summary type you want to export.","ref":"Mobius.Exports.html#t:export_metric_type/0"},{"type":"type","title":"Mobius.Exports.export_opt/0","doc":"Options to use when exporting time series metric data\n\n* `:mobius_instance` - the name of the Mobius instance you are using. Unless\n  you specified this in your configuration you should be safe to allow this\n  option to default, which is `:mobius_metrics`.\n* `:last` - display data point that have been captured over the last `x`\n  amount of time. Where `x` is either an integer or a tuple of\n  `{integer(), time_unit()}`. If you only pass an integer the time unit of\n  `:seconds` is assumed. By default Mobius will plot the last 3 minutes of\n  data.\n* `:from` - the unix timestamp, in seconds, to start querying from\n* `:to` - the unix timestamp, in seconds, to stop querying at","ref":"Mobius.Exports.html#t:export_opt/0"},{"type":"type","title":"Mobius.Exports.mfb_export_opt/0","doc":"","ref":"Mobius.Exports.html#t:mfb_export_opt/0"},{"type":"module","title":"Mobius.RRD","doc":"A round robin database for Mobius\n\nThis is the RRD used by Mobius to store historical metric data.\n\nA round robin database (RRD) is a data store that has a circular buffer to store\ninformation. As time moves forward the older data points get overwritten by\nnewer data points. This type of data storage is useful for a consistent memory\nfootprint for time series data.\n\nThe `Mobius.RRD` implementation provides four time resolutions. These are: seconds,\nminutes, hours and days. Each resolution can be configured to allow for as\nmany single data points as you see fit. For example, if you want to store three\ndays of data at an hour resolution you can configure the RRD like so:\n\n```elixir\nRRD.new(hours: 72)\n```\n\nThe above will configure the hour resolution to store 72 hours worth of data points\nin the hour archive.\n\nThe default resolutions are:\n\n* 60 days (each day for about 2 months)\n* 48 hours (each hour for 2 days)\n* 120 minutes (each minute for 2 hours)\n* 120 seconds (each second for 2 minutes)\n\nFor more information about round robin databases, RRD tool is a great resource\nto study.","ref":"Mobius.RRD.html"},{"type":"function","title":"Mobius.RRD.all/1","doc":"Return all items in order","ref":"Mobius.RRD.html#all/1"},{"type":"function","title":"Mobius.RRD.insert/3","doc":"Insert an item for the specified time","ref":"Mobius.RRD.html#insert/3"},{"type":"function","title":"Mobius.RRD.load/2","doc":"Load persisted data back into a TimeLayerBuffer\n\nThe `rrd` that's passed in is expected to be a new one without any entries.","ref":"Mobius.RRD.html#load/2"},{"type":"function","title":"Mobius.RRD.new/1","doc":"Create a new RRD\n\nThe default resolution values are:\n\n* 60 days (each day for about 2 months)\n* 48 hours (each hour for 2 days)\n* 120 minutes (each minute for 2 hours)\n* 120 seconds (each second for 2 minutes)","ref":"Mobius.RRD.html#new/1"},{"type":"function","title":"Mobius.RRD.query/2","doc":"Return all items with timestamps equal to or after the specified one","ref":"Mobius.RRD.html#query/2"},{"type":"function","title":"Mobius.RRD.query/3","doc":"Return all items within the specified range","ref":"Mobius.RRD.html#query/3"},{"type":"function","title":"Mobius.RRD.save/2","doc":"Serialize to an iolist","ref":"Mobius.RRD.html#save/2"},{"type":"type","title":"Mobius.RRD.create_opt/0","doc":"Options for the RRD\n\nFor resolution options you specify which resolution and the max number of\nmetric data to keep for that resolution.\n\nFor example, if the RRD were to track seconds up to five minutes it would need\nto track `300` seconds. Also, if the same RRD wanted to track day resolution\nfor a year, it would need to contain `365` days.\n\n```elixir\nMobius.RRD.new(seconds: 300, days: 365)\n```","ref":"Mobius.RRD.html#t:create_opt/0"},{"type":"type","title":"Mobius.RRD.resolution/0","doc":"Resolution name","ref":"Mobius.RRD.html#t:resolution/0"},{"type":"type","title":"Mobius.RRD.save_opt/0","doc":"Options for saving RRD into a binary\n\n* `:serialization_version` - the version of serialization format, defaults to\n  most recent","ref":"Mobius.RRD.html#t:save_opt/0"},{"type":"opaque","title":"Mobius.RRD.t/0","doc":"","ref":"Mobius.RRD.html#t:t/0"},{"type":"exception","title":"Mobius.DataLoadError","doc":"Used when there is problem loading data into the mobius storage","ref":"Mobius.DataLoadError.html"},{"type":"type","title":"Mobius.DataLoadError.opt/0","doc":"Options for making a `DataLoadError`\n\n- `:reason` - the reason why the data could not be loaded","ref":"Mobius.DataLoadError.html#t:opt/0"},{"type":"type","title":"Mobius.DataLoadError.t/0","doc":"","ref":"Mobius.DataLoadError.html#t:t/0"},{"type":"exception","title":"Mobius.Exports.MBFParseError","doc":"Use when there is an error parsing a Mobius Binary Format (MBF) binary","ref":"Mobius.Exports.MBFParseError.html"},{"type":"type","title":"Mobius.Exports.MBFParseError.t/0","doc":"","ref":"Mobius.Exports.MBFParseError.html#t:t/0"},{"type":"exception","title":"Mobius.Exports.UnsupportedMetricError","doc":"Error for trying to export metric types where there is no support in the\nexport implementation","ref":"Mobius.Exports.UnsupportedMetricError.html"},{"type":"type","title":"Mobius.Exports.UnsupportedMetricError.t/0","doc":"","ref":"Mobius.Exports.UnsupportedMetricError.html#t:t/0"},{"type":"exception","title":"Mobius.FileError","doc":"Used when there is an error conducting file operations","ref":"Mobius.FileError.html"},{"type":"type","title":"Mobius.FileError.t/0","doc":"","ref":"Mobius.FileError.html#t:t/0"},{"type":"extras","title":"Mobius","doc":"# Mobius\n\n[![CircleCI](https://circleci.com/gh/mobius-home/mobius/tree/main.svg?style=svg)](https://circleci.com/gh/mobius-home/mobius/tree/main)\n\n![Mobius](assets/mobius-name.png)\n\nLibrary for localized telemetry metrics","ref":"readme.html"},{"type":"extras","title":"Installation - Mobius","doc":"```elixir\ndef deps do\n  [\n    {:mobius, \"~> 0.6.1\"}\n  ]\nend\n```","ref":"readme.html#installation"},{"type":"extras","title":"Usage - Mobius","doc":"Add `Mobius` to your supervision tree and pass in the metrics you want to track.\n\n```elixir\ndef start(_type, _args) do\n  metrics = [\n    Metrics.last_value(\"my.telemetry.event\"),\n  ]\n\n  children = [\n    # ... other children ....\n    {Mobius, metrics: metrics}\n    # ... other children ....\n  ]\n\n  # See https://hexdocs.pm/elixir/Supervisor.html\n  # for other strategies and supported options\n  opts = [strategy: :one_for_one, name: MyApp.Supervisor]\n  Supervisor.start_link(children, opts)\nend\n```\n\n#","ref":"readme.html#usage"},{"type":"extras","title":"Quick tips - Mobius","doc":"To see a view of the current metrics you can use `Mobius.info/0`:\n\n```elixir\niex> Mobius.info()\nMetric Name: vm.memory.total\nTags: %{}\nlast_value: 83952736\n```\n\nTo plot a metric measurement over time you can use `Mobius.Exports.plot/4`:\n\n```elixir\niex> Mobius.Exports.plot(\"vm.memory.total\", :last_value, %{})\n                Metric Name: vm.memory.total, Tags: %{}\n\n34355808.00 ┤\n34253736.73 ┤                                    ╭──╮    ╭────╮\n34151665.45 ┤                               ╭────╯  ╰────╯    ╰───\n34049594.18 ┤         ╭────╮    ╭────╮ ╭────╯\n33947522.91 ┤         │    ╰────╯    ╰─╯\n33845451.64 ┤         │\n33743380.36 ┤    ╭────╯\n33641309.09 ┤    │\n33539237.82 ┤    │\n33437166.55 ┤    │\n33335095.27 ┼────╯\n```\n\n#","ref":"readme.html#quick-tips"},{"type":"extras","title":"Configure persistence directory - Mobius","doc":"By default Mobius will try to save metric data for all resolutions and the\ncurrent value when the erlang system exits gracefully. This makes Mobius useful\nfor Nerves devices that have to reboot after doing a planned firmware update.\nThe default direction Mobius will try to persist data to is the `/data`\ndirectory as this is friendly to Nerves devices. If you want Mobius to store\ndata in a different location you can pass that into Mobius when you start it:\n\n```elixir\n\nchildren = [\n   # ... other children ...\n   {Mobius, metrics: metrics(), persistence_dir: \"/tmp\"}\n   # ... other children ...\n]\n\ndef metrics() do\n  [\n    Metrics.last_value(\"vm.memory.total\", unit: {:byte, :kilobyte})\n  ]\nend\n```\n\n#","ref":"readme.html#configure-persistence-directory"},{"type":"extras","title":"Saving / Autosaving metrics data - Mobius","doc":"By default the metrics data is persisted on a normal shutdown. However, data\nwill not be persisted during a sudden shutdown, eg Control-C in IEX, kill,\nsudden power off.\n\nIt's possible to manually call Mobius.save/1 to force an interim write of the\npersistence data.\n\nThis can be automated by passing `autosave_interval` to Mobius\n\n```elixir\ndef start(_type, _args) do\n  metrics = [\n    Metrics.last_value(\"my.telemetry.event.measurement\"),\n  ]\n\n  children = [\n    # ... other children ....\n    {Mobius, metrics: metrics, autosave_interval: 60} # auto save every 60 seconds\n    # ... other children ....\n  ]\n\n  # See https://hexdocs.pm/elixir/Supervisor.html\n  # for other strategies and supported options\n  opts = [strategy: :one_for_one, name: MyApp.Supervisor]\n  Supervisor.start_link(children, opts)\nend\n```\n\n#","ref":"readme.html#saving-autosaving-metrics-data"},{"type":"extras","title":"Exporting data - Mobius","doc":"The `Mobius.Exports` module provide functions for exporting the data in a couple\ndifferent formats.\n\n1. CSV\n2. Series\n3. Line plot\n4. Mobius Binary Format\n\n```elixir\n# export as CSV string\nMobius.Exports.csv(\"vm.memory.total\", :last_value, %{})\n\n# export as series list\nMobius.Exports.series(\"vm.memory.total\", :last_value, %{})\n\n# export as mobius binary format\nMobius.Exports.mbf()\n```\n\nThe Mobius Binary Format (MBF) is a binary string that has encoded and\ncompressed all the historical metrics that mobius current has. This is\nmost useful for preparing metrics to send off to another system. To parse\nthe binary format you can use `Mobius.Exports.parse_mbf/1`.\n\nFor each of these you can see the `Mobius.Exports` module for more details.\n\n#","ref":"readme.html#exporting-data"},{"type":"extras","title":"Report metrics to a remote server - Mobius","doc":"Mobius allows sending metrics to a remote server. You can do this by passing the\n`:remote_reporter` option to Mobius. This is a module that implements the\n`Mobius.RemoteReporter` behaviour. Optionally, you can pass the\n`:remote_report_interval` option to specify how often to report metrics, by\ndefault this is every 1 minute.\n\n#","ref":"readme.html#report-metrics-to-a-remote-server"},{"type":"extras","title":"Events - Mobius","doc":"In a system we want to track metrics and events. Metrics are measurements\ntracked at a regular interval. These could in cloud CPU and memory usage or\nsomething like bytes transmitted over an LTE connection. Events are things\ntracked at irregular intervals that might not have a measurement. Events are\nnecessary to pin point moments in time that something of interest happens that\nisn't necessarily a measurement. For example, firmware updates and interface\nconnections.\n\nEvents are good to track things that happen at particular time that are enriched\nby extra data, whereas metrics are good for understand single piece of data over\ntime.\n\nYou can listen for raw telemetry events by passing a list of event names to\nMobius.\n\n```elixir\ndef start(_type, _args) do\n  events = [\n    \"a.button.was.pressed\"\n  ]\n\n  children = [\n    # ... other children ....\n    {Mobius, events: events, autosave_interval: 60} # auto save every 60 seconds\n    # ... other children ....\n  ]\n\n  opts = [strategy: :one_for_one, name: MyApp.Supervisor]\n  Supervisor.start_link(children, opts)\nend\n```\n\nThe above example will listen for that telemetry event and save that into\nMobius's event log.\n\nEvent configurations can take different options:\n\n* `:tags` - list of tag names to save with the event\n* `:measurement_values` - a function that will receive each measurement that\n  allows for data processing before storing the event in the event log\n* `:group` - an atom that defines the event group, this will allow for filtering\n  on particular types of events for example: `:network`. Default is `:default`\n\nFor example if a measurement is reported in naive time and you want to convert\nthat to seconds you can do that this way:\n\n```elixir\ndef start(_type, _args) do\n  events = [\n    {\"a.button.was.pressed\", measurement_values: &process_button_measurements/1}\n  ]\n\n  children = [\n    # ... other children ....\n    {Mobius, events: events, autosave_interval: 60} # auto save every 60 seconds\n    # ... other children ....\n  ]\n\n  opts = [strategy: :one_for_one, name: MyApp.Supervisor]\n  Supervisor.start_link(children, opts)\nend\n\ndefp process_button_measurement({:system_time, sys_time}) do\n  System.convert_time(sys_time, :naive, :second)\nend\n\ndefp process_button_measurement({_, value}), do: value\n```\n\nA good resource for understanding telemetry data and some of the differences\nbetween events and metrics is [New Relic's MELT 101 post](https://newrelic.com/platform/telemetry-data-101).\n\n#","ref":"readme.html#events"},{"type":"extras","title":"Clocks - Mobius","doc":"For systems that lack battery-backed real-time clock which will advance the\nclock at startup to a reasonable guess, the early events will have a timestamp\nthat do not make much sense. Mobius allows you to pass the `clock` argument\nwhich is a module that implements the `Mobius.Clock` behaviour. This behavior\nhas one callback: `synchronized?/0` which returns a boolean.\n\nIf a clock implementation is provide, Mobius will wait for the clock to\nsynchronize before including any events into the logs. Once the clock is\nsynchronized Mobius will make a best effort attempt to adjust early event\ntimestamps to reflect the actual time the event occurred and will then include\nthe events into the event log.\n\nIf no clock implementation is provided, Mobius will assume the clock is\nsynchronized and that it can trust the provided timestamps of early events.\n\nFor Nerves devices, the NervesTime package can be used:\n\n`{Mobius, metrics: my_metrics, events: my_events, clock: NervesTime}`","ref":"readme.html#clocks"},{"type":"extras","title":"Changelog","doc":"<!-- markdownlint-disable-file MD024 -->\n\n# Changelog\n\nThis project follows [Semantic Versioning](https://semver.org/spec/v2.0.0.html).\n\n> Major version zero (0.y.z) is for initial development. Anything MAY change at\nany time. The public API SHOULD NOT be considered stable.\n\n## [v0.6.1] - 2024-04-02\n\n#","ref":"changelog.html"},{"type":"extras","title":"Changed - Changelog","doc":"* Allow `:telemetry_metrics` v1.0.0 and later now that it's been released\n* Fix `Logger.warn` deprecations\n* Fix binary format validation issue due to map sort order change in Erlang 26.\n\n## [v0.6.0] - 2022-09-09\n\nThe breaking change in Mobius is the removal of remote reporting and the\nfunctionality built around that such as configuring a remote reporter to send\na metric report at some interval.\n\nIf this functionality is something you still want, you can provide a GenServer\nthat executes your reporting code at some interval. This will allow the maximum\nflexibility to how you want your software to report metrics.\n\n#","ref":"changelog.html#changed"},{"type":"extras","title":"Changed - Changelog","doc":"* Remove `Mobius.RemoteReporter`\n* Remove `:remote_reporter` configuration from `Mobius.arg()`\n* Remove `:remote_reporter_interval` configuration from `Mobius.arg()`\n* Remove `Mobius.RemoteReporters.LoggerReporter`\n\n#","ref":"changelog.html#changed"},{"type":"extras","title":"Added - Changelog","doc":"* `Mobius.Event`\n* `Mobius.EventLog`\n* `Mobius.Clock`\n* `Mobius.get_latest_metrics/1`\n* `Mobius.get_latest_events/1`\n* `:events` option to `Mobius.arg()`\n* `:event_log_size` option to `Mobius.arg()`\n* `:clock` option to `Mobius.arg()`\n* `:session` option to `Mobius.arg()`\n* `Mobius.session()`\n\n## [v0.5.1] - 2022-06-01\n\n#","ref":"changelog.html#added"},{"type":"extras","title":"Added - Changelog","doc":"- Added the ability for a remote reporter to response with\n  `{:error, reason, new_state}`.\n\n## [v0.5.0] - 2022-05-31\n\nBreaking changes for three functions in the `Mobius.Exports` module:\n\n1. `Mobius.Exports.series/4`\n1. `Mobius.Exports.metrics/4`\n1. `Mobius.Exports.plot/4`\n\nIf you are not directly calling these functions in your code you're safe to upgrade.\n\nThe first two used to return either `{:ok, results}` or `{:error, reason}` but\nnow they will only return their result. For `Mobius.Exports.series/4` the return\nvalue is now `[integer()]` and for `Mobius.Exports.metrics/4` the return type is\nnow `[Mobius.metric()]`. `Mobius.Exports.plot/4` still returns `:ok` on success,\nbut can now return `{:error, UnsupportedMetricError.t()}`.\n\n#","ref":"changelog.html#added"},{"type":"extras","title":"Changed - Changelog","doc":"* `Mobius.Exports.series/4` return type was\n  `{:ok, [integer()]} | {:error, UnsupportedMetricError.t()}` and now is\n  `[integer()]`.\n* `Mobius.Exports.metrics/4` return type was\n  `{:ok, [Mobius.metric()]} | {:error, UnsupportedMetricError.t()}` and now is\n  `[Mobius.metric()]`\n* `Mobius.Exports.plot/4` was just `:ok` but now is\n  `:ok | {:error, UnsupportedMetricError.t()}`\n\n#","ref":"changelog.html#changed"},{"type":"extras","title":"Added - Changelog","doc":"* `Mobius.RemoteReporter` behaviour to allow for reporting metrics to a remote\n  server.\n* Add `:remote_reporter` and `:remote_report_interval` options to the\n  `Mobius.arg()` type.\n* Support for specifying which summary metric you want to export. (@ewildgoose)\n* Support for summary metrics types in some exports. (@ewildgoose)\n* Add standard deviation calculation to the summary metric type. (@ewildgoose)\n* New `Mobius.Exports.export_metric_type()` that allows for specifying the\n  summary metric type.\n\n#","ref":"changelog.html#added"},{"type":"extras","title":"Misc - Changelog","doc":"* Update `ex_doc` to `v.0.28.4`\n* Update `telemetry` to `v1.1.0`\n* Fix up typos (@kianmeng)\n\n## [v0.4.0] - 2022-03-25\n\n#","ref":"changelog.html#misc"},{"type":"extras","title":"Changed - Changelog","doc":"* `Mobius.plot/3` is now `Mobius.Exports.plot/4`\n* `Mobius.to_csv/3` is now `Mobius.Exports.csv/4`\n* `Mobius.filter_metrics/3` is now `Mobius.Exports.metrics/4`\n* `Mobius.name()` is now `Mobius.instance()`\n* Mobius functions that need to know the name of the mobius instance now\n  expect `:mobius_instance` and not `:name`\n* `Mobius.metric_name()` is no longer a list of `atoms()` but is now the metric\n  name as a string\n* `Mobius.RRD` internal metric format\n* `Mobius.RRD.insert/3` typespec now expects `[Mobius.metric()]` as the last\n  parameter\n\n#","ref":"changelog.html#changed"},{"type":"extras","title":"Removed - Changelog","doc":"* `Mobius.filter_opt()` type\n* `Mobius.csv_opt()` type\n* `Mobius.plot_opt()` type\n* `Mobius.query_opts/1` function\n* `Mobius.to_csv/3` function\n* `Mobius.plot/3` function\n* `Mobius.filter_metrics/3` function\n* `Mobius.make_bundle/2` function (use `Mobius.mbf/1` instead)\n* `Mobius.Bundle` module\n* `Mobius.record()` type\n\n#","ref":"changelog.html#removed"},{"type":"extras","title":"Added - Changelog","doc":"* `Mobius.Exports` module for APIs concerning retrieving historical data in\n  various formats\n* `Mobius.Exports.csv/4` generates a CSV either as a string, to the console, or\n  to a file\n* `Mobius.Exports.series/4` generates a series for historical data\n* `Mobius.Exports.metrics/4` retrieves the raw historical metric data\n* `Mobius.Exports.plot/4` generates a line plot to the console\n* `Mobius.Exports.mbf/1` generates a binary that contains all current metrics\n* `Mobius.Exports.parse_mbf/1` parses a binary that is in the Mobius Binary Format\n* `Mobius.Exports.UnsupportedMetricError`\n* `Mobius.Exports.MBFParseError`\n* `Mobius.FileError`\n* `:name` field to `Mobius.metric()` type\n\n## [v0.3.7] - 2022-03-16\n\nThis release brings in a bunch of new features and bug fixes. Along with\nbasic maintenance like dependency updates and documentation improvements\n(@ewildgoose).\n\n#","ref":"changelog.html#added"},{"type":"extras","title":"Added - Changelog","doc":"* Create, save, and extract tar files that contain metric data, see\n  `Mobius.Bundles` and `Mobius.make_bundle/2` for more information.\n* `Mobius.filter_metrics/3` to filter for desired metrics to enable the\n  metrics to be consumed externally (@ewildgoose)\n* `Mobius.save/1` to manually save the state of the metric data for Mobius\n  (@ewildgoose)\n* `:autosave_interval` option to Mobius to enable a saving data at the given\n  interval (@ewildgoose)\n\n#","ref":"changelog.html#added"},{"type":"extras","title":"Fixes - Changelog","doc":"* Unit conversion not working correctly (@ewildgoose)\n* Error handling for when the `:persistence_path` is missing (@ewildgoose)\n* Error handling when there is no data to plot (@ewildgoose)\n* Crash when plotting an array of identical values (@ewildgoose)\n* Correct off by one error when plotting (@ewildgoose)\n\n## [v0.3.6] - 2022-01-25\n\n#","ref":"changelog.html#fixes"},{"type":"extras","title":"Added - Changelog","doc":"* Support for `Telemetry.Metrics.Summary` metric type\n\n## [v0.3.5] - 2021-12-2\n\n#","ref":"changelog.html#added"},{"type":"extras","title":"Fixes - Changelog","doc":"* Fix crash when initializing metrics table when the ETS file cannot be read (@jfcloutier)\n\n## [v0.3.4] - 2021-11-15\n\n#","ref":"changelog.html#fixes"},{"type":"extras","title":"Fixes - Changelog","doc":"* Fix crash when a history file is unreadable during initialization (@mdwaud)\n\n## [v0.3.3] - 2021-10-20\n\n#","ref":"changelog.html#fixes"},{"type":"extras","title":"Fixes - Changelog","doc":"* Not able to pass a path for persistence that contains non-existing sub\n  directories. Thank you [LostKobrakai](https://github.com/LostKobrakai).\n\n## [v0.3.2] - 2021-09-22\n\n#","ref":"changelog.html#fixes"},{"type":"extras","title":"Added - Changelog","doc":"* Support for `Telemetry.Metrics.Sum` type\n* Support for filtering CSV records by type with `:type` option\n\n## [v0.3.1] - 2021-09-08\n\n#","ref":"changelog.html#added"},{"type":"extras","title":"Added - Changelog","doc":"* Plot over the last `x` seconds via the `:last` plot option\n* Plot from an absolute time via the `:from` plot option\n* Plot to an absolute time via the `:to` plot option\n* Print or save metric time series via `Mobius.to_csv/3`\n* Remove tracking a metric by dropping it from the metric list passed to Mobius\n\n#","ref":"changelog.html#added"},{"type":"extras","title":"Changed - Changelog","doc":"* `Mobius.plot/3` will only show the last 3 minutes of data by default\n\n## [v0.3.0] - 2021-8-19\n\n#","ref":"changelog.html#changed"},{"type":"extras","title":"Changed - Changelog","doc":"* Deleted `Mobius.Charts` module. The functions in this module are now located\n  in the `Mobius` module.\n\n#","ref":"changelog.html#changed"},{"type":"extras","title":"Removed - Changelog","doc":"* Support for specifying resolutions.\n\n## [v0.2.0] - 2021-8-03\n\n#","ref":"changelog.html#removed"},{"type":"extras","title":"Added - Changelog","doc":"* `Mobius.Charts` module\n* Persistence of historical information on graceful shutdown\n* Ability to specify time resolutions for plots\n\n#","ref":"changelog.html#added"},{"type":"extras","title":"Changed - Changelog","doc":"* Move `Moblus.plot/0` and `Mobius.info/0` to `Mobius.Charts` module","ref":"changelog.html#changed"},{"type":"extras","title":"v0.1.0 - 2021-7-16 - Changelog","doc":"Initial release!\n\n[v0.6.1]: https://github.com/mattludwigs/mobius/compare/v0.6.0...v0.6.1\n[v0.6.0]: https://github.com/mattludwigs/mobius/compare/v0.5.1...v0.6.0\n[v0.5.1]: https://github.com/mattludwigs/mobius/compare/v0.5.0...v0.5.1\n[v0.5.0]: https://github.com/mattludwigs/mobius/compare/v0.4.0...v0.5.0\n[v0.4.0]: https://github.com/mattludwigs/mobius/compare/v0.3.7...v0.4.0\n[v0.3.7]: https://github.com/mattludwigs/mobius/compare/v0.3.6...v0.3.7\n[v0.3.6]: https://github.com/mattludwigs/mobius/compare/v0.3.5...v0.3.6\n[v0.3.5]: https://github.com/mattludwigs/mobius/compare/v0.3.4...v0.3.5\n[v0.3.4]: https://github.com/mattludwigs/mobius/compare/v0.3.3...v0.3.4\n[v0.3.3]: https://github.com/mattludwigs/mobius/compare/v0.3.2...v0.3.3\n[v0.3.2]: https://github.com/mattludwigs/mobius/compare/v0.3.1...v0.3.2\n[v0.3.1]: https://github.com/mattludwigs/mobius/compare/v0.3.0...v0.3.1\n[v0.3.0]: https://github.com/mattludwigs/mobius/compare/v0.2.0...v0.3.0\n[v0.2.0]: https://github.com/mattludwigs/mobius/compare/v0.1.0...v0.2.0","ref":"changelog.html#v0-1-0-2021-7-16"}],"content_type":"text/markdown","producer":{"name":"ex_doc","version":[48,46,51,49,46,50]}}